$debug
      SUBROUTINE SMODC
C    EXECUTION OF RETAIL MODEL
$include:'sscom1'                                                   
$include:'sscom2'                                                   
$include:'sscom3'                                                   
$include:'sscom4'                                                   
      real trips(20),xjoint,trsum(20)                                   
      integer ntrold,itrpt,itract,ntr,ijnt,out                          
c                                                                       
      MLOC = 7
      do 130 out=11,11
      WRITE(OUT,150) NLOC                                               
      WRITE(OUT,151)                                                    
      DO 90 IL=1,NLOC                                                   
   90 WRITE(OUT,157) NAME(IL),(XLOC(IL,J),J=1,9)                           
      WRITE(OUT,152)                                                    
      WRITE(OUT,153)                                                    
      WRITE(OUT,158) BETA1(2) 
      write(out,161)
      write(out,158) zeta1(2) 
      write(out,162)
      write(out,158) -beta1(1),beta1(3)
      write(out,161)
      write(out,158) -zeta1(1),zeta1(3)
      WRITE(OUT,154)                                                    
      WRITE(OUT,159)                                                    
      WRITE(OUT,158) (BETA2(J),J=1,MLOC)                                
      MLOC = 7
      write(out,161)
      write(out,158) (zeta2(j),j=1,mloc)
      mloc = 7
      WRITE(OUT,160) NTRACT
130   continue                                                          
c                                                                       
  150 FORMAT(1H1/5X,'NO. OF SHOPPING CENTERS',11X,I2)                          
  151 FORMAT(//'LOCATION CHARACTERISTICS'/1X,'SHOP CTR',6X,'SF'
     *,3X,'PSPA',2X,'NSTR',2X,'NDIS',2X,'NDEP',2X,
     3 'NVGM',2X,'NFRN',2X,'NEAT',2X,'PCOS'/)
  152 FORMAT(//'ACCESS COEFFICIENTS'/)
  153 FORMAT(/' AUTOTIME'/)
  154 FORMAT(//'SHOP ATTRACTION COEFFICIENTS'/)
  159 FORMAT(/'   SQR. FT.',2X,'# STORES',2X,'# DISCNT',2X,'# DEPTS',
     *2X,'# VAR-GEN',2X,'# FURNIT',2X,'# EATERY'/)
  155 FORMAT(2X,13F6.1)
  156 FORMAT(1H1)                                                       
  157 FORMAT(A10,3X,9F6.0)
  158 FORMAT(10F10.5)                                                
  160 FORMAT(///'NO. OF TRACTS',15X,I4)
  161 FORMAT('INCOME LEVEL CORRELATION OF FACTORS')
  162 FORMAT(//,'LOCATION SPECIFIC CONSTANTS',/,'  BOSTON   BACK BAY')
C                                                                       
C INITIALIZE.                                                           
C                                                                       
      DO 200 IL=1,NLOC                                                  
      BIGM(IL)= 0.0                                                     
      TRIPS(IL)= 0.0                                                    
      DO 190 IT=1,NTIMES                                                
  190 FREQL(IL,IT)= 0.0                                                 
      DO 200 IH=1,NINC                                                  
      DO 195 J=1,2                                                      
  195 SPEND(IL,IH,J)= 0.0                                               
      DO 200 K=1,NMARK                                                  
  200 MARKET(IL,IH,K)= 0.0                                              
      DO 210 IH=1,NINC                                                  
      DO 210 K=1,4                                                      
      TOTF(IH,K)= 0.0                                                   
      DO 210 IT=1,NTIMES                                                
  210 FREQ(IH,K,IT)= 0.0                                                
C  COMPUTE LOCATION UTILITIES
C
      do 250 ih=1,ninc
      DO 250 IL=1,NLOC                                                  
       yloc(il,1)=xloc(il,1)-xloc(1,1)
       yloc(il,2)=xloc(il,3)-xloc(1,3)
       yloc(il,3)=xloc(il,4)-xloc(1,4)
       yloc(il,4)=xloc(il,5)-xloc(1,5)
       yloc(il,5)=xloc(il,6)-xloc(1,6)
       yloc(il,6)=xloc(il,7)-xloc(1,7)
       yloc(il,7)=xloc(il,8)-xloc(1,8)
      VLOC(IL,IH)= 0.0                                                     
      DO 250 JA=1,MLOC                                                  
      VLOC(IL,IH)=VLOC(IL,IH)+yLOC(IL,JA)*(BETA2(JA)+ZETA2(JA)*XINC(IH))
  250 CONTINUE                                                          
      do 251 out=11,11
      write(out,259)
        WRITE(out,260) (name(il),il=1,nloc)
      do 251 ih=1,ninc
 251    WRITE(out,255) IH,(VLOC(IL,IH),IL=1,NLOC)                             
  255 format(I2,13F6.1)                                              
      WRITE(*,272) (name(il),il=1,nloc)
      do 252 ih=1,ninc
  252 write(*,155) (vloc(il,ih),il=1,nloc)
  259 format(/'SHOP CENTER LOGIST ATTRACTION FACTORS BY INCOME GROUP')
  260 FORMAT(/,' I ',13(A5,1X))
  270 FORMAT('1'/'***   TOTAL TRIPS FROM EACH CENSUS TRACT TO EACH',
     *' SHOPPING LOCATION   ***'//'CENSUS   SHOP CENTER')
  272 FORMAT(2X,13(A5,1X))
C                                                                       
C COMPUTE MARKET SHARES FOR EACH TRACT (TMARK).                         
C                                                                       
      NTROLD= 0                                                         
      ITRPT= 0                                                          
      ITRACT= 0                                                         
C                                                                       
C INPUT ACCESS DATA FOR THE TRACT (T-TIME, A-TIME) AND TRANSF INTO 
C FORM REQ'D BY THE SHOPPING TRIP MODEL (XLC).                               
C                                                                       
  290 READ(13,300,END=1200) NTR,MODE,(TTIME(IL),IL=1,NLOC)
      READ(13,300,END=999) NTR,MODE,(ATIME(IL),IL=1,NLOC)
      ITRACT= ITRACT+1                                                  
  300 FORMAT(4x,I3,I3,f8.0,8x,12f8.0)
       IF(MODE.EQ.2) GO TO 301
  315  WRITE(*,316) NTR
  316  FORMAT('ACCESS OR POP DATA TRACT NUMBERING ERROR, TRACT:',I4)
  301  CONTINUE
       DO 304 IL=1,NLOC
       GO TO 304
       TCOST(IL)=50
  304  ACOST(IL)=ATIME(IL)*2
C                                                                       
      CALL GENXLC(NTR)                                                  
C                                                                       
C IF A NEW TRACT (IJNT=0), INPUT SOCIO-ECONOMIC MARGINALS AND CREATE THE
C JOINT DISTRIBUTION.                                                   
C                                                                       
C                                                                       
C OUTPUT TOTAL TRIPS FROM LAST CENSUS TRACT TO EACH SHOPPING LOCATION.  
C                                                                       
  313 FORMAT(I4,1X,8F9.2)                                               
      NTROLD= NTR                                                       
      DO 314 IL=1,NLOC                                                  
  314 TRIPS(IL)= 0.0                                                    
      ITRPT= ITRPT+1                                                    
      if(itrpt-10*(itrpt/10).eq.0) write(*,3141) itrpt                  
3141  format(' Analyzing ',i4,'-th zone.. . .')                         
  320 CALL GENJNT(ntr,itrpt)
C                                                                       
C COMPUTE MARKET SHARES FOR EACH SOCIO-ECONOMIC GROUP.                  
C                                                                       
  350 DO 1000 IH=1,NINC                                                 
      IF (XINC(IH).LE.0.0) GO TO 290
C                                                                       
C ADD INCOME EFFECTS TO XLC.                                            
C                                                                       
      DO 400 IL=1,NLOC                                                  
      GO TO 390
      IF (MAVAIL(IL,2).EQ.0) GO TO 390                                  
      XLC(IL,4,2)= TCOST(IL)/XINC(IH)                                  
  390 XLC(IL,3,1)= XLOC(IL,9)-XLOC(1,9)
  400 MAVAIL(IL,1)=1
C                                                                       
      DO 900 IA=1,NAUTO                                                
C                                                                       
      FLAG=1                                                            
      IF (IA.EQ.1.AND.MALT.EQ.0) GO TO 445                              
C
C    IF NO CAR OR TRANSIT ALTERNATIVE IS AVAILABLE
      XJOINT= JOINT(IA,IH)                                              
      IF (XJOINT.EQ.0.0) GO TO 900                                     
      GO TO 421
C                                                                       
C ADD AUTO OWNERSHIP EFFECTS TO XLC.                                    
C                                                                       
      DO 420 IL=1,NLOC                                                  
  420 XLC(IL,1,3)= FLOAT(IA-1)                                          
C                                                                       
  421 flag=0
      CALL WORK(XJOINT,IH)
C                                                                       
      IF (IA.GT.1) GO TO 469                                            
C   IF NO CAR OR TRANSIT IS AVAILABLE THEN DO:
  445 DO 450 IL=1,NLOC                                                  
      IF (atime(il) .GT.0.0) MAVAIL(IL,3)= 1                            
  450 CONTINUE                                                          
  469 IF (FLAG) 470,490,900                                            
  470 WRITE(*,480) ITRACT,NTR,IA,IH                                    
  480 FORMAT(5X,'ITRACT,NTR,IA,IH=',4I5)                                
      GO TO 900                                                        
C                                                                       
C ADD EXPENDITURES, TRAVEL TIME FREQ. DIST'N AND MARKET SHARES.         
C                                                                       
  490 DO 500 IL=1,NLOC                                                  
      IF (TMARK(IL,4).LE.0.0) GO TO 500                                 
      SPEND(IL,IH,1)= SPEND(IL,IH,1)+TMARK(IL,4)*R(IH)                  
      TRIPS(IL)= TRIPS(IL)+TMARK(IL,4)                                  
      DO 495 K=1,1
      IT= ITIME(IL,K)                                                   
      FREQ(IH,K,IT)= FREQ(IH,K,IT)+TMARK(IL,K)                          
      FREQL(IL,IT)= FREQL(IL,IT)+TMARK(IL,K)                            
  495 FREQ(IH,4,IT)= FREQ(IH,4,IT)+TMARK(IL,K)                          
  498 DO 499 K=1,1
  499 MARKET(IL,IH,K)= MARKET(IL,IH,K)+TMARK(IL,K)                      
  500 CONTINUE                                                          
      NTROLD= NTR                                                       
C                                                                       
900     continue
 1000 CONTINUE
      go to 290
C                                                                       
C         WARNING THAT THE WRONG NUMBER OF TRACTS WERE READ IN.          
C                                                                       
  999 WRITE(*,9999)                                                    
      WRITE(*,9999)                                                     
 9999 FORMAT(//5X,'*** ERROR WRONG NUMBER OF TRACTS READ IN ***',//)  
C                                                                       
 1200 WRITE(*,312) NTROLD,(TRIPS(IL),IL=1,NLOC)                        
  312 FORMAT(2X,I4,8X,6F10.2/4X,7F10.2)
 1250 WRITE(*,1251) ITRACT                                             
      WRITE(11,1251) ITRACT                                             
      WRITE(*,1251) ITRACT                                              
 1251 FORMAT(//5X,'NO. OF MODE/TRACT COMBINATIONS ANALYZED:',I4)
C                                                                       
      DO 1500 K=1,NMARK                                                 
      DO 1500 IL=1,NLOC                                                 
      RSUM= 0.0                                                         
      DO 1420 IH=1,NINC                                                 
 1420 RSUM= RSUM+MARKET(IL,IH,K)                                        
      TRSUM(IL)= RSUM                                                   
 1500 CONTINUE                                                          
      DO 1600 I=1,1                                                     
      DO 1600 IL=1,NLOC                                                 
      DO 1600 IH=1,NINC                                                 
      BIGM(IL)= BIGM(IL)+SPEND(IL,IH,I)                                 
      IF (I.EQ.2) GO TO 1600                                            
      DO 1599 K=1,4                                                     
 1599 TOTF(IH,K)= TOTF(IH,K)+MARKET(IL,IH,K)                            
 1600 CONTINUE                                                          
C                                                                       
      DO 1820 IH=1,NINC                                                 
      DO 1820 K=1,1                                                     
      DO 1820 IT=1,NTIMES                                               
      IF (TOTF(IH,K).LE.0.0) GO TO 1820                                 
      FREQ(IH,K,IT)= FREQ(IH,K,IT)/TOTF(IH,K)                           
 1820 CONTINUE                                                          
C                                                                       
      DO 1870 IL=1,NLOC                                                 
      DO 1870 IT=1,NTIMES                                               
      IF (TRSUM(IL).LE.0.0) GO TO 1870                                  
      FREQL(IL,IT)= FREQL(IL,IT)/TRSUM(IL)                              
 1870 CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                               
c                                                                       
      SUBROUTINE GENXLC(NTR)                                            
C                                                                       
C THIS SUBROUTINE TAKES ACCESS DATA (TIME AND ATIME) AND PARKING DATA
C (XLOC) AND GENERATES THE ACCESS VARIABLES (XLC) REQ. BY THE MODEL
C (IN THE SUBROUTINE WORK), FOR THE AVAIL MODES (MVAIL), FOR EACH TRACT
C TO ALL SHOPPING LOCATIONS.                                                   
C                                                                       
$include:'sscom1'                                                   
$include:'sscom2'                                                   
$include:'sscom3'
$include:'sscom4'                                                   
      DIMENSION ICNTR(20),IGBND(20)
      MALT= 0                                                           
      DO 1000 IL=1,NLOC                                                 
C                                                                       
C SET UP TRAVEL TIME AND COST POINTERS FOR TRIP FREQ. CALCULATIONS.         
C                                                                       
       GO TO 44
       TIME(IL,2)=TTIME(IL)
       TIME(IL,3)=ATIME(IL)
   44  TIME(IL,1)=ATIME(IL)
      DO 50 K=1,1                                                       
      IF (TIME(IL,K).GT.0.0) GO TO 45                                   
      ITIME(IL,K)= 1                                                    
      TIME(IL,K)= 0.0                                                   
      GO TO 50                                                          
C   TRANSIT TIME= VEHICLE TIME + 9 MIN WALK, EGRESS,ETC
   45 TIME(IL,2)= TTIME(IL)+9
C   AUTO TIME = VEHICLE TIME + PARK TIME
   46 TIME(IL,1)=ATIME(IL)+(XLOC(IL,9)/70+5)
      ITIME(IL,K)= IFIX(TIME(IL,K))+2                                   
      ntimes = 92
      IF (ITIME(IL,K).GT.NTIMES) ITIME(IL,K)= NTIMES                    
   50 CONTINUE                                                          
C                                                                       
C MAVAIL(IL,KM)= 1 IF IL IS AVAILABLE TO THIS TRACT BY MODE KM          
C (=0 OTHERWISE).                                                       
C MALT=1 IF A TRANSIT ALT. EXISTS FOR THIS TRACT (=0 OTHERWISE)
C                                                                       
C         THE FOLLOWING LOOP ZEROS OUT XLC EVEN FOR ELEMENTS NOT USED.  
C                                                                       
      DO 100 KM=1,1                                                     
      DO 90 JLOS=1,3                                                    
   90 XLC(IL,JLOS,KM)= 0.0                                              
  100 continue
      GO TO 101
      mavail(il,2)=0
  101 mavail(il,1)=1
      GO TO 300
C TRANSIT MODE
C                                                                       
      IF (TTIME(IL).LE.0.0)   GO TO 300                                 
C                                                                       
C MAX. TOTAL TRANSIT TIME ALLOWED = 45 MIN.                             
C                                                                       
      IF (TIME(IL,2).LE.45.0) GO TO 210    
C   TRANSIT TIME OVER LIMIT
      ITIME(IL,2)= 1.0                                                  
      TIME(IL,2)= 0.0                                                   
  209 TTIME(IL)=-1
      GO TO 300                                                         
C  TRANSIT TIME WITHIN LIMIT
  210 XLC(IL,6,2)= 0.0                                                  
C   TRANSIT CONSTANT IS XLC(IL,6,2)
      XLC(IL,3,2)=TIME(IL,2)
C    TRANSIT TRAVEL TIME = XLC(IL,3,2)
C    (TCOST IS EVENTUAL COMPONENT OF ALC(IL,4,2,))
      MAVAIL(IL,2)= 1                                                   
      MALT= 1                                                           
C                                                                       
C AUTO MODE.                                                            
C                                                                       
  300 IF (ACOST(IL).LE.0.0) GO TO 1000
       ACOST(IL)=ACOST(IL)+XLOC(IL,9)
C   ( ACOST IS EVENTUAL COMPONENT OF XLC(IL,3,1))
      GO TO 301
      XLC(IL,2,1)= 1.0                                                  
C  AUTO  CONSTANT
  301 XLC(IL,2,1)= TIME(IL,1)-TIME(1,1)
C   AUTO TRAVEL TIME
 1000 CONTINUE                                                          
C                                                                       
      RETURN                                                            
      END                                                               
C
C THIS SUBROUTINE GENERATES JOINT DISTRIBUTIONS FOR ACCESS AND
C POPULATION CHARACTERISTICS
      SUBROUTINE GENJNT(ntr,ITRPT)
      DIMENSION COL(7),NBD(7),XXI(5),hhinc(5)
$include:'sscom1'                                                   
$INCLUDE:'SSCOM2'
$INCLUDE:'SSCOM4'
$include:'sscom3'
      DATA NBD(1),NBD(2),NBD(3),NBD(4),NBD(5),NBD(6)/9,18,27,36,45,50/
C                                                                       
C , COMPUTE XINC (THE AVERAGE INCOME), AND 
C  THE EXPENDITURE LEVEL, FOR EACH INCOME CATEGORY.           
C                                                                       
      DO 119 I=1,5
  119 hhinc(i)=yinc(itrpt,i)
      j=itr(itrpt)
      IF (NTR.EQ.j) GO TO 320
      WRITE(*,315) ITRACT,NTR,ITRPT,ITR(ITRPT)                         
  315 FORMAT(//5X,'***   ERROR . . . ACCESS AND POP DATA ARE FOR ',     
     *'DIFFERENT TRACTS   ***'//10X,'ITRACT,NTR,ITRPT,ITR(ITRPT)=',4I5//
     *5X,'***   EXECUTION TERMINATING   ***')                           
      stop
 320  I1= 1
      DO 100 ICAT=1,NINC                                                
      R(ICAT)= 0.0                                                      
      R(ICAT)= EXPFUN(ICAT) * XINC(ICAT)                                      
  100 I1= I2+1                                                          
C                                                                       
C GENERATE THE NUMBER IN EACH JOINT INCOME-AUTO OWN.COMBINATION
C                                                                       
      DO 200 I=1,NAUTO                                                  
      DO 200 J=1,NINC                                                   
  200 JOINT(I,J)= F(I,J)*hhinc(j)
C                                                                       
      RETURN                                                            
      END                                                               
C
C
      SUBROUTINE WORK(XJOINT,IH)                                        
C                                                                       
C THIS SUBROUTINE USES A LOGIT SHOPPING TRIP MODEL TO PREDICT           
C AGGREGATE SHARES BY MODE (TMARK) FOR EACH SHOPPING CENTER FOR EVERY
C  TRACT AND INCOME GROUP
C                                                                       
$include:'sscom1'                                                   
$INCLUDE:'SSCOM2'
$include:'sscom3'                                                   
$include:'sscom4'                                                   
      DIMENSION EV(20,4),PROB(20,4),PMODE(20,3) 
C                                                                       
C COMPUTE UTILITIES (RM:1=AUTO)
C                                                                       
      FLAG= 0                                                           
      SUM= 0.0                                                          
      DO 200 IL=1,NLOC                                                  
      EV(IL,1)= 0.0
      EV(IL,4)= 0.0                                                     
      DO 150 KM=1,1
      EV(IL,KM)= 0.0                                                    
      GO TO 118
      IF (MAVAIL(IL,KM).EQ.0) GO TO 150                                 
  118 V= VLOC(IL,IH)                                                    
      DO 120 JLOS=1,MLOS                                                
      xlc(il,1,km)=1
      xlc(1,1,km)=0
      xlc(il,3,km)=0
      xlc(2,3,km)=1
  120 V= V+(BETA1(JLOS)+ZETA1(JLOS)*XINC(IH))*XLC(IL,JLOS,KM)
      EV(IL,KM)= EXP(V)
      EV(IL,4) = EV(IL,4) + EV(IL,KM)
  150 CONTINUE                                                          
      SUM= SUM + EV(IL,4)                                               
C                                                                       
  200 CONTINUE                                                          
C                                                                       
C                                                                       
C COMPUTE PROBABILITIES.                                                
      DO 500 IL=1,NLOC                                                  
      DO 260 K=1,1                                                      
      PROB(IL,K)= 0.0                                                   
  260 TMARK(IL,K)= 0.0                                                  
      DO 280 KM=1,1                                                     
  280 PMODE(IL,KM)= 0.0                                                 
      IF (SUM.NE.0.0) GO TO 340                                         
      WRITE(*,320)                                                     
  320 FORMAT(//2X,'... WARNING ... SUM OF UTILITIES =0')
      FLAG= -1                                                          
      RETURN                                                            
  340 IF (EV(IL,4).EQ.0.0) GO TO 500                                    
      PROB(IL,4)= EV(IL,4)/SUM                                          
      DO 420 KM=1,1                                                     
      PMODE(IL,KM)= 1                                                   
  420 PROB(IL,KM)= PMODE(IL,KM)*PROB(IL,4)                              
C                                                                       
C COMPUTE MARKET SHARES.                                                
      DO 460 K=4,4
  460 TMARK(IL,K)= PROB(IL,K)*XJOINT
      tmark(il,1)=tmark(il,4)
  500 CONTINUE                                                          
      RETURN                                                            
      END                                                               
 

