      subroutine spspec                                                 
C     MODIFY INPUT DATA BY MENU CHOICE
$include:'sscom1'                                                   
$include:'sscom2'
$include:'sscom3'                                                   
1     format(1x,a)                                                      
2     format(1x,a,i5)                                                   
50    write(*,1) 'Input Menu'                                           
      write(*,1) '(1) auto ownership by income class'
      write(*,2) '(2) No. of Shopping centers'
      write(*,1) '(3) Shopping Center Characteristics'
      write(*,1) '(4) Access coefficients'
      write(*,1) '(5) Shop attraction coefficients'
      write(*,1) '(0) Return to Main Menu'                              
      write(*,1) 'Enter selection:'                                     
      call iisafe(iopt,0,5)                                             
      if(iopt.eq.0) return                                              
      go to (100,200,300,400,500) iopt                                  
100   write(*,1) 'Auto Ownership by income class'
      write(*,1) 'Income group, proportion with 0,1,2+ cars'
      do 110 j=1,5
110     write(*,1001) j,(f(i,j),i=1,3)                                  
1001    format(' (',i2,') ',3f6.3)                                      
      write(*,1) '( 0) Return to Input Menu'                            
      write(*,1) 'Enter row number:'                                    
      call iisafe(jj,0,9)                                              
      if(jj.eq.0) go to 50                                              
      write(*,1) 'Enter index:'                                         
      call iisafe(ii,1,3)                                               
      write(*,1) 'Enter value:'                                         
      call irsafe(f(ii,jj),0.,1.)                                       
      go to 100                                                         
200   write(*,1) 'Enter new value for no. of centers:'
      call iisafe(nloc,1,20)                                            
      go to 50                                                          
300   write(*,1) 'Shopping Center Characteristics'
      write(*,3002)
 3002 format(' ROW   NAME    SQFT #SPC #STOR #DIS #DEP #VGM #FRN',
     1 ' #EAT PCOST')
      do 310 i=1,nloc                                                   
310     write(*,3001) i,name(i),(xloc(i,j),j=1,9)
3001    format(I3,2X,A10,9F5.0)
      write(*,1) '( 0) Return to Input Menu'                            
      write(*,1) 'Enter row number:'                                    
      call iisafe(ii,0,nloc)                                            
      if(ii.eq.0) go to 50                                              
      write(*,1) 'Enter index:'                                         
      call iisafe(jj,1,9)
      write(*,1) 'Enter value:'                                         
        call irsafe(xloc(ii,jj),0.,10000.)                               
      go to 300                                                         
400   write(*,1) 'Access coefficients'
      write(*,1) 'constant, atime, pcost'
      do 410 j=1,mlos                                                   
410     write(*,4001) j,beta1(j)                                        
      write(*,1) 'income-correlation coefficients'
      do 420 j=1,mlos
420   write(*,4001) j+mlos,zeta1(j)
4001    format(' (',i2,') ',f10.6)                                      
      write(*,1) '( 0) Return to Input Menu'                            
      write(*,1) 'Enter selection:'                                     
      call iisafe(jj,0,mlos*2)                                        
      if(jj.eq.0) go to 50                                              
      write(*,1) 'Enter new value:'                                     
      call irsafe(beta1(jj),-10.,100.)                                  
      go to 400                                                         
500   write(*,1) 'Shop Attraction Coefficients'
      write(*,1) 'sq.ft,#store,#dis,#dep,nvgm,nfrn,neat'
      do 510 j=1,mloc                                                   
510     write(*,4001) j,beta2(j)                                        
      write(*,1) 'income-correlation coefficients'
      do 520 j=1,mloc
520     write(*,4001) mloc+j,zeta2(j)
      write(*,1) '( 0) Return to Input Menu'                            
      write(*,1) 'Enter selection:'                                     
      call iisafe(jj,0,mloc*2)
      if(jj.eq.0) go to 50                                              
      write(*,1) 'Enter new value:'                                     
      call irsafe(beta2(jj),-10.,100.)                                  
      go to 500                                                         
      end                                                               
